package tests;

import references.references.BooleanReference;
import references.references.NumberReference;
import references.references.StringReference;

import static JSON.Comparator.Comparator.JSONCompare;
import static JSON.Validator.Validator.IsValidJSON;
import static references.references.references.*;
import static testEscaper.testEscaper.TestEscaper;
import static testReader.testReader.*;
import static testTokenizer.testTokenizer.*;
import static testWriter.testWriter.*;
import static testing.testing.testing.AssertFalse;
import static testing.testing.testing.AssertTrue;

public class tests {
    public static double test(){
        NumberReference failures;

        failures = CreateNumberReference(0d);

        TestReader(failures);
        Test2(failures);
        TestWriter(failures);
        TestWriterEscape(failures);
        TestTokenizer1(failures);
        TestReaderExample(failures);
        TestEscaper(failures);
        TestValidator(failures);
        TestComparator(failures);
        TestWriter2(failures);
        TestWriter3(failures);

        return failures.numberValue;
    }

    public static void TestValidator(NumberReference failures) {
        char [] a, b, c, d;
        StringReference message;

        message = CreateStringReference( "".toCharArray());

        a = "{\"a\":\"hi\",\"b\":[1.2, 0.1, 100],\"x\":{\"x1\":null,\"x2\":true,\"x3\":false}}".toCharArray();
        b = "{{}}]".toCharArray();
        c = "".toCharArray();
        d = "{".toCharArray();

        AssertTrue(IsValidJSON(a, message), failures);
        AssertFalse(IsValidJSON(b, message), failures);
        AssertFalse(IsValidJSON(c, message), failures);
        AssertFalse(IsValidJSON(d, message), failures);
    }

    public static void TestComparator(NumberReference failures) {
        char [] a, b;
        StringReference message;
        BooleanReference equalsReference;
        boolean success;

        message = CreateStringReference( "".toCharArray());
        equalsReference = CreateBooleanReference(false);

        a = "{\"a\":\"hi\",\"b\":[1.2, 0.1, 100],\"x\":{\"x1\":null,\"x2\":true,\"x3\":false}}".toCharArray();
        b = "{\"x\":{\"x1\":null,\"x2\":true,\"x3\":false},\"a\":\"hi\",\"b\":[1.2, 0.1, 100]}".toCharArray();

        success = JSONCompare(a, b, 0.0001, equalsReference, message);

        AssertTrue(success, failures);
        AssertTrue(equalsReference.booleanValue, failures);

        a = "{\"a\":\"hi\",\"b\":[1.201, 0.1, 100],\"x\":{\"x1\":null,\"x2\":true,\"x3\":false}}".toCharArray();
        b = "{\"x\":{\"x1\":null,\"x2\":true,\"x3\":false},\"a\":\"hi\",\"b\":[1.2, 0.1, 100]}".toCharArray();

        success = JSONCompare(a, b, 0.0001, equalsReference, message);

        AssertTrue(success, failures);
        AssertFalse(equalsReference.booleanValue, failures);

        success = JSONCompare(a, b, 0.1, equalsReference, message);

        AssertTrue(success, failures);
        AssertTrue(equalsReference.booleanValue, failures);
    }
}
